# Changelog

GSL changes from releases. You can send an issue :
- repo: https://git.a-lec.org/echolib/gsl/-/issues
- Contact xmpp: im@echolib.re

## [0.1.10]
- Fix: file for links
- added: setdir (DO IT on your articles folder)
- - files and images folders are created in articles folder
- changes: check for files and images in files and images folder from articles folder
- - no more check for existing files in GSL DOMAIN/ template
- If no error in article, copy (if exists) files and images (with sub-folder) to GSL DOMAIN/


## [0.1.9]
### Added:
- gawk dependance

### Changes
- date: Format YYYY-MM-DD (in RAW article only)
- - new page|post follows this rule
- HTML markers
- - strong: '¤'
- - Inline-code: '`'
- - Bold: ```*```
- - Emphasis: ```\```
- - Cross: '×' ; was strike. Use it to customize your text with CSS
- - del: '~'
- new article creator ; gsl new page 404


## [0.1.8]
- fix: logs field from sidebar
- Add: abbr 3rd field value. If set output HTML in lower case


## [0.1.7]
- fix: FR Date on sidebar
- sync: exclude hidden files from templates


## [0.1.6]
- fix: FR date on template only ; replace "-" with "/"


## [0.1.5}
- fix: sidebar item link with add/replace


## [0.1.4]
- fix: $(site_css) in sidebar


## [0.1.3]
### Fix:
- invalid argument
- site_css variable called in sidebar
- make : even if page created, article must be check if changed

### Changes
- images marker in content: use external http/ftp link
- - No more needed unity:   defaut "px" if not known in content marker
- - See examples output HTML in help folder (how-to_Tips_And_Advises.md)
- - See main usage in help folder (comment_ecrire_article.md)
- Ask to confirm both wip & www sync with gsl sync

### Add
- Stats : local link from slug (/...) counted after new check if added to www


## [0.1.0]
### First beta release
- fix www/wip with add/remove options
- fix some innvalid HTML codes (strike uses span now)
- Renamed documentation files (not all translated ; some in french)
- RSS feed donc after all www (command) done


## [0.0.93]
### New
- Basic RSS feed created at each www (COMMAND)
- - on root server: /DOMAIN/www/rss.xml
- Basic footer with new list (added RSS feed).
- - Do not forget to add link in your footer, to /rss.xml

### Fix
- www add: when type is post
- log: field "server" for WIP


## [0.0.92]
### Fix
- make: must not use -F if article has changed


## [0.0.92]
### Fix
- Valid style for img: width & height in one style=""


## [0.0.90]
### Changes
- Statoolinfos: Genereated with www (add/remove)
- CSS div between titles : xxx_content xxx_content-hX


## [0.0.9]

## Please, see help (and documentations in help folder)

### Add
- New code about everywhere, more comments, cleaner
- nano dependence
- Check installed configuration at launch
- Dedicated functions for ARGUMENTS in specific files category
- - check:             gsl__post_checkers
- - make,sidebar:      gsl__post_makers
- - sync,www,wip       gsl__srv_manager
- - log:               gsl__log_manager
- - db:                gsl__db_manager
- - author,new,setdir: gsl__domain_manager
- - edit:              gsl__edit_file
- - stats:             gsl__stats

### Installation
- new files:
- - gsl__srv_manager:     for all about server
- - gsl__version:         for -v, -vv, --version options
- - gsl__domain_manager:  for OPT author, new, setdir
- - gsl__edit_file:       functions to edit some configuration files
- - gsl__do_commons:      Common functions to filter article lines
- - gsl__HTML_template:   functions to create HTML pages
- New empty folder in installation:
- - /var/lib/gsl/db:      for all DBs (.gitkepp)
- - /var/lib/gsl/domains: for all domains (.gitkeep)
- - /var/log/gsl:         for logs files (.gitkeep)
- New help folder in
- - /var/lib/gsl/help     (removed "helps" one)

### Logs
- Better logs harmony
- New fields in log for article filename and domain name
- Specific number of characters spaces in some log fields
- More verbose
- "automatic" level log set from called functions
- Colored levels: war (yellow), err (red)

### Databases
- Dedicated per article
- Folder: /var/lib/gsl/db/
- New file format: domains.db
- More datas with new stats. Quicker sourced datas
- Dedicated articles in sub-directory "DOMAIN"
- Check if corrupted DB
- Database and wip files won't be removed if errors in article
- If corrupted Database, try restoring www & wip statuses at new check

### Changes
- Changes in mapping process:
- - Processes get needed headers FIRST, then split article in 2 sections
- DOMAIN Profile is only in /var/lib/gsl/domains/DOMAIN/
- Variables in DOMAIN.conf file has no more "gsl_"
- Some translated words in HTML page from lang set DOMAIN (fr || en)
- Between markers (code): put "everything" you want
- New CSS classes: see gsl help css or documentation
- Mark image (i.e. "_image:1:mycss:50%:25%:+)"
- - define your own css class 'mycss'
- - define unity ("%","px"... with height and witdth)
- New lists. Mix "+" (ol) and "=" (ul) and write an item on several lines
- Between hX titles: new div css (none if empty content)
- Changing article Type will remove old wip file (not www file !)
- sync: Logs not shown but added
- stats properties file is now in /www (online)

### Process check [argument]
- slug: log err if already exists (log war if not well formated)

### new ARGUMENTS
- new (page|post) (name): Create article, show its content + check it
- new domain:   New domain configuration creator
- edit domains: Set/Edit registred domains database
- edit author:  Same as author edit
- author edit:  Opens nano to Add/Remove authors (one per line) by DOMAIN
- setdir:       Set current folder for your DOMAIN (show if one)
- check -N:     Only check newer articles not in DB
- clean all:    Remove all backups (only) files 
- sidebar:      add|replace|latest|oldest (See gsl help)
- www sync:     Same as sync www
- wip ...:      Same as www but for wip

### Markers
- css: MYCLASS  Customize each article with your CSS (optional)
- brut:         Insert brut code from file
- - In article header:  "NBR : FILENAME"``
- - In article content: "_brut: NBR"
- "_image:VALUE:MYCSS:WIDTH:HEIGHT:TARGET" (no target=no HTML link)
- Strong mark:   '•...•' (alt+gr + ;) on french azerty keyboard)
- Bold mark:     '·...·' (alt+gr + :) on french azerty keyboard)
- Emphasis mark: '”...”' (alt+gr + n) on french azerty keyboard)
- Strike mark:   '×...×' (alt+gr + shift + ;) on french azerty keyboard
- ```<<``` and ```>>``` as "start" and "close" marker for lists

### Template
- included basic header, metas and footer
- All about template is in /var/lib/gsl/scripts/gsl__HTML_template
- - No more header.html in templates folder
- - - Edit your own in create__HTML_header() function
- In /var/lib/gsl/domains/DOMAIN/templates/
- - Auto created metas.html and footer.html if not exist
- - Edit your own footer.html 
- - Edit your own metas per DOMAIN for HTML ```<head>``` in metas.html
- - - included basic pre-registred meta from datas article
- - No CSS styles included: create your own (see classes and IDs used in doc)
- For all changes here, after gsl make, use gsl sync...

### Sidebar
- No more /var/lib/gsl/domains/DOMAIN/templates/last-posts-list.html
- - Remove it with files xxx.X in /var/lib/gsl/domains/DOMAIN/X-tra/
- New HTML file: /var/lib/gsl/domains/DOMAIN/templates/sidebar.html
- - Created with files /var/lib/gsl/domains/DOMAIN/X-tra/sidebar/(POS).html
- articles are sorted from epoch date (in DB) with false time at check

### Statoolinfos (added properties for www status)
- gsl.articles
- gsl.articles.pages
- gsl.articles.posts
- gsl.authors
- gsl.articles.tags
- gsl.articles.words
- gsl.articles.quotes
- gsl.articles.paragraphs
- gsl.articles.links
- gsl.articles.links.online
- gsl.articles.lists
- gsl.articles.lists.items
- gsl_articles.images

### CRITIK
- Remove all files in /var/lib/gsl/db/
- Use: ```gsl new domain```, give your registred DOMAIN name
- - Answer Y to autofix old configurations files and folders
- - Do it for each DOMAIN you registred
- - will add site_max_list=5 (default) in domain configuration file
- Use ```gsl check``` in your articles folder


## [0.0.37]
### Add
- changelog
- Make stats at each www call
- Set yourself a class ID for paragraphs: i.e. "( 1a"
- Better Logs harmony
- date: Set to DD-MM-YYYY if site lang=fr || YYYY-MM-DD
- date: Check for month value > 12
- some changed syntax in make process

### Fix
- link: check only online url from http...
- if 'error' log : do not exit 1 anymore
- variable name propertie for stats (statoolinfos)

## [0.0.36]

### Add
- New list converter (Use + for ol, not ø)
- New block titles converter with div
- New option: create
- New option with edit: conf (to edit domain configuration)
- New option: --version (to show last changes)
- New generic function if invalid option
- New min size for post: 150

### Fix
- No ```<div></div>``` if block title empty
