# Comment installer GSL: Statique Littératueur
------------------------------------------------------------------------

- Un script d'installation install.sh est prévu, mais pas encore proposé.
- Un .deb peut être créé (merci neox) depuis le make de l'archive

## Installation manuelle
- git clone https://git.a-lec.org/echolib/gsl && cd gsl
- Commencez par créer les dossiers de base (voir ci-dessous)
- Donnez leur les droits nécessaires

GSL n'utilise pas de droits sudo, et a besoin pour écrire certains
fichiers et créer certains dossiers d'être propriétaire ou d'avoir les
droits en écriture des dossiers

```
# Pour le dossier du binaire
sudo rsync -a usr/local/bin/gsl /usr/local/bin/gsl
sudo chown USER:GROUP /usr/local/bin/gsl

# Pour les dossiers de scripts
sudo mkdir -p "/var/lib/gsl"
sudo chown -R USER:GROUP /var/lib/gsl
rsync -a var/lib/gsl/ /var/lib/gsl/

# Pour le dossier de logs
sudo mkdir -p "/var/log/gsl"
sudo chown -R USER:GROUP /var/log/gsl

# Pour le dossier de configuration
sudo mkdir -p /etc/gsl
sudo chown -R USER:GROUP /etc/gsl
rsync -a etc/gsl/ /etc/gsl/

# Pour l'autocompletion des articles dans la commande
sudo rsync -a usr/share/bash-completion/completions/gsl /usr/share/bash-completion/completions/gsl
sudo chown USER:GROUP /usr/share/bash-completion/completions/gsl
```

Attention: GSL aura besoin de créer des sous-dossier dans le serveur,
renseigné dans le questionnaire. (i.e. /var/www/). Il faut donc lui
donner les droits

# Arborescence des dossiers utilisés par GSL
------------------------------------------------------------------------
Note:
- ```+``` indique que GSL créera ces dossiers
- DOMAIN représente le nom de domaine renseigné dans le questionnaire

- /etc/gsl
- /var/log/gsl
- /var/lib/gsl
- - /help/
- - /scripts/
- - /domains
- - - /DOMAIN +
- - - - /templates/ +
- - - - /files/ +
- - - - /images/ +
- - - - /X-tra +
- - - - - /sidebar +
- - /db
- - - /DOMAIN +

- /SRV (i.e. /var/www)
- - /DOMAIN +
- - - /wip +
- - - - /TEMPLATE (sync wip (command) from /var/lib/gsl/domains/DOMAIN/) +
- - - /www +
- - - - /TEMPLATE (sync www (command) from /var/lib/gsl/domains/DOMAIN/) +


# Fichiers créés par GSL
------------------------------------------------------------------------

- /var/log/gsl
- - gsl.log
- - Y-M-D-H-M-S.gsl.log (backup when clean ; removed with clean all)
- /var/lib/gsl
- - /domains
- - - DOMAIN
- - - - authors.db
- - - - DOMAIN.conf
- - /db/
- - - domains.db (registred domains)
- - - DOMAIN/
- - - - (article).gsl.db (un par article)
